// BMPwatcher.cpp : implementation file
//

#include "stdafx.h"
#include "BmpWork.h"
#include "UsualIncludes1153_bmpwork.h"
#include "BMPwatcher.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBMPwatcher
// -     

CBMPwatcher::CBMPwatcher()
{
	m_nXscrollShiftOf100percent=0;
	m_nYscrollShiftOf100percent=0;
}

CBMPwatcher::~CBMPwatcher()
{
}


BEGIN_MESSAGE_MAP(CBMPwatcher, CStatic)
	//{{AFX_MSG_MAP(CBMPwatcher)
	ON_WM_PAINT()
	ON_WM_DROPFILES()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBMPwatcher message handlers

void CBMPwatcher::OnPaint() 
{
	CPaintDC dcReal(this);

	//  
	def_PaintWithNoBlink(dcReal,PaintControl);
}

//   
void CBMPwatcher::PaintControl(CDC &dc, long ldcW, long ldcH)
{
	// 
	dc.FillSolidRect(0,0,ldcW,ldcH,_sysgreycolor);

	// 
	m_Bitmap.Paint_OnDc(dc,ldcW,ldcH,ldcW*m_nXscrollShiftOf100percent/100,ldcH*m_nYscrollShiftOf100percent/100);
}

//     
void CBMPwatcher::OnDropFiles(HDROP hDropInfo) 
{
	if(m_Bitmap.GetMode()==e_RGB_parent)//  "" 
	{
		//   
		DWORD dwdCount=DragQueryFile(hDropInfo,-1,0,0);

		if(dwdCount==1)
		{
			//  1 

			char* pName[MAX_PATH];
			memset(pName,0,sizeof(pName));

			//   
			DWORD dwdGotSymbs=DragQueryFile(hDropInfo,0,(char*)pName,sizeof(pName));

			// 
			OpenTheFile((const char*)pName);
		}
	}

	CStatic::OnDropFiles(hDropInfo);
}

// 
void CBMPwatcher::OpenTheFile(const char *pFileFullPath_w_ext)
{
	s_TempFileHandle FileHandle;

	m_csLastLoadedFile=pFileFullPath_w_ext;

	// 
	FileHandle.hFile=CreateFile(pFileFullPath_w_ext,GENERIC_READ,0,0,OPEN_EXISTING,0,0);
	if(!FileHandle.IsValid())
	{
		MessageBox("  ",0,MB_ICONASTERISK|MB_SYSTEMMODAL);
		return;
	}

	//  
	s_TempBuff TempBuf(GetFileSize(FileHandle.hFile,0));
	if(!TempBuf.GetBuff())
	{
		MessageBox("     ",0,MB_ICONHAND|MB_SYSTEMMODAL);
		return;
	}
	DWORD dwdRead=0;
	if(!ReadFile(FileHandle.hFile,TempBuf.GetBuff(),TempBuf.GetLen(),&dwdRead,0) || TempBuf.GetLen()!=dwdRead)
	{
		MessageBox("   ",0,MB_ICONHAND|MB_SYSTEMMODAL);
		return;
	}

	// "" 
	CString csError="";
	if(!m_Bitmap.CreateNewFromBitmapFileArray(TempBuf.GetBuff(),TempBuf.GetLen(),&csError))
	{
		if(csError!="")
		{
			MessageBox(csError,0,MB_ICONEXCLAMATION|MB_SYSTEMMODAL);
		}
	}

	//""   , ,  CBmpWorkDlg::OnPaint()
	//   m_Bitmap.m_Params.m_bFileJustLoaded (  
	//  CreateNewFromBitmapFileArray)    
	GetParent()->Invalidate(1);
}

//    ( )
void CBMPwatcher::OnRButtonUp(UINT nFlags, CPoint point) 
{
	CString txt=m_Bitmap.GetMatrixLikeString();

	if(txt!="")
	{
		MessageBox(txt);
	}
	
	CStatic::OnRButtonUp(nFlags, point);
}
