// BmpWorkDlg.h : header file
//

#if !defined(AFX_BMPWORKDLG_H__8C8F4256_B9FF_41B1_B5B4_056744690932__INCLUDED_)
#define AFX_BMPWORKDLG_H__8C8F4256_B9FF_41B1_B5B4_056744690932__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CBmpWorkDlg dialog

#include "BMPwatcher.h"

class CBmpWorkDlg : public CDialog
{
// Construction
public:
	void ResetControlsWhenFileJustLoaded();
	void CorrectYUVRGBlabels();
	void OpenTheFileInDialog(const char *pFileFullPath_w_ext);
	CBmpWorkDlg(CWnd* pParent);
	void MakeCaptionText();

// Dialog Data
	//{{AFX_DATA(CBmpWorkDlg)
	enum { IDD = IDD_BMPWORK_DIALOG };
	CBMPwatcher	m_IDC_RGBsrc;
	CBMPwatcher	m_IDC_V;
	CBMPwatcher	m_IDC_U;
	CBMPwatcher	m_IDC_Y;
	CBMPwatcher	m_IDC_RGBnew_main;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBmpWorkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CBmpWorkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnchkRGBajust();
	afx_msg void OnbnSave();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnbnResetAll();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BMPWORKDLG_H__8C8F4256_B9FF_41B1_B5B4_056744690932__INCLUDED_)
